# OptimizationProblems.jl

This package provides a collection of optimization problems in
[JuMP](https://github.com/JuliaOpt/JuMP.jl) and [ADNLPModels](https://github.com/JuliaSmoothOptimizers/ADNLPModels.jl) syntax.

## Installing

OptimizationProblems can be installed and tested through the Julia package manager:

```julia
julia> ]
pkg> add OptimizationProblems
pkg> test OptimizationProblems
```

## How to cite

If you use OptimizationProblems.jl in your work, please cite using the format given in [CITATION.bib](https://github.com/JuliaSmoothOptimizers/OptimizationProblems.jl/blob/main/CITATION.bib).

# Bug reports and discussions

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/OptimizationProblems.jl/issues).
Focused suggestions and requests can also be opened as issues. Before opening a pull request, start an issue or a discussion on the topic, please.

If you want to ask a question not suited for a bug report, feel free to start a discussion [here](https://github.com/JuliaSmoothOptimizers/Organization/discussions). This forum is for general discussion about this repository and the [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers), so questions about any of our packages are welcome.
